## Smart Arrays Base


### What the package can do for you
This package provides basic functionalities for one- and two-dimensional arrays (vectors and matrices). 


### The major API functionalities

- class `Array1D`: This class provides utility functions for 1D arrays (vectors):
    - adding arrays with various options
    - Finding the minimum or maximum values with various options
    - splitting, shuffling, swapping and extracting given index ranges
    - extending with zeroes, cutting
    
- class `Array2D`:This class provides utility functions for 2D arrays (matrices):
   - Extracting rows, columns, appending rows
   - Extracting sub-matrices, building envelopes
   - Computing projections or sums over rows or columns
   - Swapping or reversing rows
   - Finding minimum or maximum values
 

#### Detailed API
Please view the detailed API documentation in the `API` reference of this package (sidebar at the right of this page).


### Using this package
You need Dart 2.0 or later.

Import the package using:
- `import 'package:smart_arrays_base/smart_arrays_base.dart';`

### Related packages

[Please click here for advanced smart packages dealing with arrays](https://smart.specpad.bplaced.net)
